# BitBanana Code of Conduct

Like the technical community as a whole, the BitBanana community is made up of a mixture of professionals and volunteers from all over the world, working on every aspect of the mission - including mentorship, teaching, and connecting people.

Diversity is one of our huge strengths, but it can also lead to communication issues and unhappiness. To that end, we have a few ground rules that we ask people to adhere to. This code applies equally to founders, mentors and those seeking help and guidance.

This isn’t an exhaustive list of things that you can’t do. Rather, take it in the spirit in which it’s intended - a guide to make it easier to enrich all of us and the technical communities in which we participate.

_This code of conduct applies to all spaces managed by the BitBanana project. This includes the issue tracker, discord channel, social media and any other communication channels the community uses for communication._


- **Be friendly and patient.**
- **Be welcoming.** We strive to be a community that welcomes and supports people of all backgrounds and identities. This includes, but is not limited to members of any race, ethnicity, culture, national origin, colour, immigration status, social and economic class, educational level, sex, sexual orientation, gender identity and expression, age, size, family status, political belief, religion, and mental and physical ability.
- **Be considerate.** Your work will be used by other people, and you in turn will depend on the work of others. Any decision you take will affect users and colleagues, and you should take those consequences into account when making decisions. Remember that we're a world-wide community, so you might not be communicating in someone else's primary language.
- **Be respectful.** Not all of us will agree all the time, but disagreement is no excuse for poor behavior and poor manners. We might all experience some frustration now and then, but we cannot allow that frustration to turn into a personal attack. It’s important to remember that a community where people feel uncomfortable or threatened is not a productive one. Members of the BitBanana community should be respectful when dealing with other members as well as with people outside the BitBanana community.
- **Be careful in the words that you choose.** Remember that sexist, racist, and other exclusionary jokes can be offensive to those around you. Be kind to others. Do not insult or put down other participants. Behave professionally. Remember that harassment and sexist, racist, or exclusionary jokes are not appropriate for the community.
- **When we disagree, try to understand why.** Disagreements, both social and technical, happen all the time and BitBanana is no exception. It is important that we resolve disagreements and differing views constructively. Remember that we’re different. The strength of BitBanana comes from its varied community, people from a wide range of backgrounds. Different people have different perspectives on issues. Being unable to understand why someone holds a viewpoint doesn’t mean that they’re wrong. Don’t forget that it is human to err and blaming each other doesn’t get us anywhere. Instead, focus on helping to resolve issues and learning from mistakes.

Credits for the sources and inspiration of this code of conduct go to the [SpeakUp!][speakup] Project, as well as the [Django][django] Project.


If you have any questions, please feel free to [contact](mailto:bitbananawallet@proton.me?subject=BitBanana:%20Code%20of%20Conduct) us.


[speakup]: http://web.archive.org/web/20141109123859/http://speakup.io/coc.html

[django]: https://www.djangoproject.com/conduct/